• poj1006 Biorhythms


    Biorhythms
    Time Limit: 1000MS   Memory Limit: 10000K
    Total Submissions: 150111   Accepted: 48560

    Description

    Some people believe that there are three cycles in a person's life that start the day he or she is born. These three cycles are the physical, emotional, and intellectual cycles, and they have periods of lengths 23, 28, and 33 days, respectively. There is one peak in each period of a cycle. At the peak of a cycle, a person performs at his or her best in the corresponding field (physical, emotional or mental). For example, if it is the mental curve, thought processes will be sharper and concentration will be easier. 
    Since the three cycles have different periods, the peaks of the three cycles generally occur at different times. We would like to determine when a triple peak occurs (the peaks of all three cycles occur in the same day) for any person. For each cycle, you will be given the number of days from the beginning of the current year at which one of its peaks (not necessarily the first) occurs. You will also be given a date expressed as the number of days from the beginning of the current year. You task is to determine the number of days from the given date to the next triple peak. The given date is not counted. For example, if the given date is 10 and the next triple peak occurs on day 12, the answer is 2, not 3. If a triple peak occurs on the given date, you should give the number of days to the next occurrence of a triple peak. 

    Input

    You will be given a number of cases. The input for each case consists of one line of four integers p, e, i, and d. The values p, e, and i are the number of days from the beginning of the current year at which the physical, emotional, and intellectual cycles peak, respectively. The value d is the given date and may be smaller than any of p, e, or i. All values are non-negative and at most 365, and you may assume that a triple peak will occur within 21252 days of the given date. The end of input is indicated by a line in which p = e = i = d = -1.

    Output

    For each test case, print the case number followed by a message indicating the number of days to the next triple peak, in the form: 

    Case 1: the next triple peak occurs in 1234 days. 

    Use the plural form ``days'' even if the answer is 1.

    Sample Input

    0 0 0 0
    0 0 0 100
    5 20 34 325
    4 5 6 7
    283 102 23 320
    203 301 203 40
    -1 -1 -1 -1

    Sample Output

    Case 1: the next triple peak occurs in 21252 days.
    Case 2: the next triple peak occurs in 21152 days.
    Case 3: the next triple peak occurs in 19575 days.
    Case 4: the next triple peak occurs in 16994 days.
    Case 5: the next triple peak occurs in 8910 days.
    Case 6: the next triple peak occurs in 10789 days.

    题意:输入四个数e,p,i,d;分别代表在周期23,28,33中的峰值,d代表开始的时间,问:
    在d的多少天之后这三个周期同时出现峰值

    中国剩余定理

    #include<iostream>
    #include<string.h>
    #include<math.h>
    #define max 0x3f3f3f3f
    #define ll long long
    #define mod 1000000007
    using namespace std;
    ll x,y;
    ll a[3],b[3];
    void exgcd(ll a, ll b, ll &x, ll &y)    //拓展欧几里得
    {
        if(!b) 
            x = 1, y = 0;
        else
        {
            exgcd(b, a % b, y, x);
            y -= x * (a / b);
        }
    }
    ll china()
    {
        ll ans=0,lcm=1,x,y;
        for(ll i=1;i<=3;++i) //因为b[i]中的数字都是互质的,所以lcm是乘积
            lcm*=b[i];
        for(ll i=1;i<=3;++i)
        {
            ll tp=lcm/b[i];//tp是伪基础数
            exgcd(tp,b[i],x,y);//求逆元
            x=(x%b[i]+b[i])%b[i];//得到x的最小正整数解
            ans=(ans+tp*x*a[i])%lcm;//得到真正的基础数,再求和
        }
        return (ans+lcm)%lcm;
    }
    
    int main()
    {
        ll h1,h2,h3,d,t=1;
        while(scanf("%lld%lld%lld%lld",&h1,&h2,&h3,&d))
        {
            if(h1==-1&&h2==-1&&h3==-1&&d==-1)
                break;
            a[1]=h1%23,a[2]=h2%28,a[3]=h3%33;
            b[1]=23,b[2]=28,b[3]=33;
            ll num;
            num=china();
            if(num>d)
                printf("Case %lld: the next triple peak occurs in %lld days.
    ",t++,num-d);
            else
                printf("Case %lld: the next triple peak occurs in %lld days.
    ",t++,23*28*33+num-d);
        }
        return 0;
    }
    
    
    
    
    
  • 相关阅读:
    秦腾与教学评估【前缀和+二分】
    c++中成员函数声明时const得作用
    分形【递归】
    飞行兄弟【二进制枚举+异或】
    爬取4k图片网图片
    爬虫爬取博客园文章的文字【练手】
    【YBTOJ】求 f 函数
    【YBTOJ】划分数列
    【学习笔记】高斯消元法
    【Luogu P4588】 [TJOI2018]数学计算
  • 原文地址:https://www.cnblogs.com/-citywall123/p/10692721.html
Copyright © 2020-2023  润新知